/*  
 
    enRay, a realtime raytracer written in C
    Copyright (C) 2002  Antonis Stampoulis

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 */

#ifndef _parse_h_
#define _parse_h_

#include "gendefs.h"

typedef struct {

  char  *code;
  float *constants;
  float *variables[6];
  bool   rexist;
  
} Expression;

float parserEvaluate (Expression *which, float x, float y, float z);
Expression *parserNewExpression (char *source);
void parserDestroyExpression (Expression *);

#endif


